<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:a4j="http://richfaces.org/a4j"
      xmlns:rich="http://richfaces.org/rich"
      xmlns:fn="http://java.sun.com/jsp/jstl/functions"
      xmlns:composite="http://java.sun.com/jsf/composite"
      xmlns:c="http://java.sun.com/jsp/jstl/core">

    <composite:interface>
    </composite:interface>

    <composite:implementation>
        <f:loadBundle
            basename="org.inra.ecoinfo.refdata.jsf.refdataManagementPanel"
            var="refdataManagementPanel" />
        <h:outputStylesheet library="css"
                            name="org/inra/ecoinfo/refdata/jsf-refdataManagementPanel-styles.css" />

        <a4j:jsFunction name="deleteNewLine"
                        action="#{uiRefdata.actionDeleteNewLine}" execute="@this"
                        render="panelValuesMetadatas,saveButton" limitRender="true">
            <a4j:param name="param1" assignTo="#{uiRefdata.columnEdited.rowIndex}" />
        </a4j:jsFunction>


        <a4j:jsFunction name="deleteLine"
                        action="#{uiRefdata.actionDeleteLine}" execute="@this"
                        render="panelValuesMetadatas,saveButton,popupSaveDatasConfirmation"
                        limitRender="true"
                        oncomplete="#{rich:component('popupSaveDatasConfirmation')}.show()">
            <a4j:param name="param1" assignTo="#{uiRefdata.columnEdited.rowIndex}" />
        </a4j:jsFunction>

        <a4j:jsFunction name="editColumn"
                        action="#{uiRefdata.actionEditColumn}" execute="@this"
                        render="panelValuesMetadatas,saveButton" limitRender="true"
                        oncomplete="#{rich:component('popupSaveDatasConfirmation')}.show();#{rich:component('popupEditCellRefdata')}.hide();">
            <a4j:param name="param1" assignTo="#{uiRefdata.columnEdited.value}" />
            <a4j:param name="param2" assignTo="#{uiRefdata.columnEdited.rowIndex}" />
            <a4j:param name="param3"
                       assignTo="#{uiRefdata.columnEdited.columnIndex}" />
        </a4j:jsFunction>

        <a4j:jsFunction name="editColumnWithRefresh"
                        action="#{uiRefdata.actionEditColumn}" execute="@this"
                        render="dataTableAddNewRefdata,newLinevalidatePanel"
                        limitRender="true">
            <a4j:param name="param1" assignTo="#{uiRefdata.columnEdited.value}" />
            <a4j:param name="param2" assignTo="#{uiRefdata.columnEdited.rowIndex}" />
            <a4j:param name="param3"
                       assignTo="#{uiRefdata.columnEdited.columnIndex}" />
        </a4j:jsFunction>

        <a4j:jsFunction name="editColumnWithoutRefresh"
                        action="#{uiRefdata.actionEditColumn}" execute="@this"
                        render="newLinevalidatePanel" limitRender="true">
            <a4j:param name="param1" assignTo="#{uiRefdata.columnEdited.value}" />
            <a4j:param name="param2" assignTo="#{uiRefdata.columnEdited.rowIndex}" />
            <a4j:param name="param3"
                       assignTo="#{uiRefdata.columnEdited.columnIndex}" />
        </a4j:jsFunction>

        <a4j:jsFunction name="displayPopupEditCellRefdata" execute="@this"
                        render="popupEditCellRefdata" limitRender="true"
                        oncomplete="#{rich:component('popupEditCellRefdata')}.show()">
            <a4j:param name="param1" assignTo="#{uiRefdata.columnEdited.value}" />
            <a4j:param name="param2" assignTo="#{uiRefdata.columnEdited.rowIndex}" />
            <a4j:param name="param3"
                       assignTo="#{uiRefdata.columnEdited.columnIndex}" />
            <a4j:param name="param4"
                       assignTo="#{uiRefdata.columnEdited.isLongString}" />
        </a4j:jsFunction>

        <a4j:status name="statusUploadFileRefdata" onstart="alert('passe')" />

    <div style="display:none">
        <rich:popupPanel id="popupSaveDatasConfirmation" autosized="true"
                             modal="true" moveable="true">
                <f:facet name="header">
                    <h:outputText escape="false"
                                  value="#{refdataManagementPanel.PARAM_MSG_ALERT_CONFIRM}" />
                </f:facet>
                <f:facet name="controls">
                    <h:graphicImage name="close.png" library="images" styleClass="logout"
                                    onclick="#{rich:component('popupSaveDatasConfirmation')}.hide(); return false;" />
                </f:facet>
                <h:panelGroup style="width:300px; text-align: left;" layout="block">
                    <p class="intro">#{refdataManagementPanel.PARAM_MSG_ALERT_CONFIRM_CHANGE}</p>
                    <h:panelGroup rendered="#{uiRefdata.countDeletedLines>0}"
                                  styleClass="alertToDelete">
                        <h:graphicImage name="warning.png" library="images" />
                        <h:outputText escape="false"
                                      value="#{refdataManagementPanel.PARAM_MSG_YOU_ARE_DELETED}#{uiRefdata.countDeletedLines} #{refdataManagementPanel.PARAME_MSG_LINE}#{uiRefdata.countDeletedLines>1?'s':''}" />
                        <br />
                        <h:outputText escape="false"
                                      value="#{refdataManagementPanel.PARAM_MSG_ALERT_FOR_ROLLBACK}" />
                        <br />
                    </h:panelGroup>


                    <p class="intro">#{refdataManagementPanel.PARAM_MSG_CONFIRM_SAVE}</p>

                    <h:panelGroup layout="block" styleClass="logoutButtons">
                        <a4j:commandButton
                            value="#{refdataManagementPanel.PARAM_MSG_CONFIRM}"
                            action="#{uiRefdata.saveRefdatas}" execute="@this"
                            limitRender="true" status="statusSave"
                            render="popupSaveDatasConfirmation,panelValuesMetadatas,saveButton"
                            onbegin="#{rich:component('popupSaveDatasConfirmation')}.hide()" />

                        <a4j:commandButton
                            value="#{refdataManagementPanel.PARAM_MSG_CANCEL}"
                            oncomplete="#{rich:component('popupSaveDatasConfirmation')}.hide(); return false;"
                            execute="@none" render="@none" limitRender="true" />
                    </h:panelGroup>
                </h:panelGroup>

            </rich:popupPanel>

        <rich:popupPanel id="popupUploadRefdata" autosized="false" width="500"
                             height="350" modal="true" moveable="true"
                             styleClass="uploadFilesToCheckPopup">
                <f:facet name="header">
                    <h:outputText escape="false"
                                  value="#{refdataManagementPanel.PARAM_MSG_PUBLISH_REFDATAS}" />
                </f:facet>
                <f:facet name="controls">
                    <h:graphicImage name="close.png" library="images" styleClass="logout"
                                    onclick="#{rich:component('popupUploadRefdata')}.hide(); return false;" />
                </f:facet>
                <h:panelGroup layout="block">
                    <h:outputText
                        value="#{refdataManagementPanel.PARAM_MSG_PUBLISH_HELP}"
                        styleClass="intro" escape="false" />
                </h:panelGroup>
                <h:form>
                    <rich:fileUpload id="panelUploadFileRefdata"
                                     addLabel="#{refdataManagementPanel.PARAM_MSG_ADD_FILE}"
                                     acceptedTypes="csv" render="panelDetailsMetadata"
                                     onuploadcomplete="#{rich:component('popupUploadRefdata')}.hide()"
                                     fileUploadListener="#{uiRefdata.listenerUploadRefdata}"
                                     execute="@form"
                                     uploadLabel="#{refdataManagementPanel.PARAM_MSG_DO_UPLOAD}"
                                     styleClass="uploadPanel"
                                     deleteLabel="#{refdataManagementPanel.PARAM_MSG_DELETE}"
                                     clearAllLabel="#{refdataManagementPanel.PARAM_MSG_DROP_ALL}"
                                     clearLabel="#{refdataManagementPanel.PARAM_MSG_DROP}"
                                     doneLabel="#{refdataManagementPanel.PARAM_MSG_DONE}"
                                     ontyperejected="alert('#{refdataManagementPanel.PARAM_MSG_ONLY_CSV_FILE_ALERT}');"
                                     maxFilesQuantity="20">
                        <f:facet name="label">
                            <h:outputText value="{_KB}KB from {KB}KB uploaded --- {mm}:{ss}" />
                        </f:facet>
                    </rich:fileUpload>

                </h:form>

            </rich:popupPanel>

        <rich:popupPanel id="popupEditCellRefdata" autosized="true"
                             modal="true" moveable="true">
                <f:facet name="header">
                    <h:outputText
                        value="#{refdataManagementPanel.PARAM_MSG_UPDATE_ENTRY}"
                        style="display: block;" />
                </f:facet>
                <f:facet name="controls">
                    <h:graphicImage name="close.png" library="images" styleClass="logout"
                                    onclick="#{rich:component('popupEditCellRefdata')}.hide(); return false;" />
                </f:facet>
                <h:panelGroup layout="block">
                    <h:outputText
                        value="#{refdataManagementPanel.PARAM_MSG_CHANGE_VALUE}"
                        styleClass="intro" />


                </h:panelGroup>
                <h:form
                    onsubmit="#{rich:component('popupEditCellRefdata')}.hide(); return false;">
                    <h:inputText value="#{uiRefdata.columnEdited.value}"
                                 onchange="editColumn(this.value,#{uiRefdata.columnEdited.rowIndex},#{uiRefdata.columnEdited.columnIndex});"
                                 rendered="#{not uiRefdata.columnEdited.isLongString}" />

                    <h:inputTextarea value="#{uiRefdata.columnEdited.value}"
                                     styleClass="inputTextAreaLongString"
                                     onchange="editColumn(this.value,#{uiRefdata.columnEdited.rowIndex},#{uiRefdata.columnEdited.columnIndex}); "
                                     rendered="#{uiRefdata.columnEdited.isLongString}" />
                </h:form>


            </rich:popupPanel>

        <rich:popupPanel id="popupAddNewRefdata" autosized="true" modal="true"
                             moveable="true" maxHeight="400">
                <f:facet name="header">
                    <h:outputText value="#{refdataManagementPanel.PARAM_MSG_ADD_REFDATA}"
                                  style="display: block;" />
                </f:facet>
                <f:facet name="controls">
                    <h:graphicImage name="close.png" library="images" styleClass="logout"
                                    onclick="deleteNewLine(0); #{rich:component('popupAddNewRefdata')}.hide(); return false;" />
                </f:facet>
                <h:panelGroup layout="block">
                    <h:outputText
                        value="#{refdataManagementPanel.PARAM_MSG_CHANGE_VALUE}"
                        styleClass="intro" />

                </h:panelGroup>

                <a4j:outputPanel id="scrollBarAddNewRefData" layout="block"
                                 styleClass="scrollBarAddNewRefData" ajaxRendered="true">
                    <rich:dataTable
                        value="#{uiRefdata.lineModelGridMetadataEdited.columnsModelGridMetadatas}"
                        id="dataTableAddNewRefdata" var="columnModelGridMetadatas"
                        rowKeyVar="index" styleClass="dataTableAddNewRefdata">
                        <rich:column styleClass="header">
                            <h:outputLabel
                                styleClass="#{columnModelGridMetadatas.mandatory or columnModelGridMetadatas.isNKey?'mandatory':''}"
                                value="#{columnModelGridMetadatas.header ne null?columnModelGridMetadatas.header:uiRefdata.modelGridMetadata.headersColumns[index]}" />

                        </rich:column>
                        <rich:column>
                            <h:form>
                                <rich:autocomplete mode="ajax"
                                                   rendered="#{columnModelGridMetadatas.autoComplete ne null and !columnModelGridMetadatas.isListValues and !columnModelGridMetadatas.isLongString}"
                                                   autocompleteList="#{columnModelGridMetadatas.autoComplete.listOfPossibilitiesByRef}"
                                                   value="#{columnModelGridMetadatas.value}"
                                                   onchange="editColumnWithoutRefresh(this.value, 0,#{index});"
                                                   minChars="0" autofill="true">
                                </rich:autocomplete>
                                <h:inputText
                                    rendered="#{columnModelGridMetadatas.autoComplete eq null and !columnModelGridMetadatas.isListValues and !columnModelGridMetadatas.isLongString}"
                                    value="#{columnModelGridMetadatas.value}"
                                    onchange="editColumnWithoutRefresh(this.value, 0,#{index});"
                                    id="toto" required="true" />
                                <rich:message for="toto" />
                                <h:selectOneMenu value="#{columnModelGridMetadatas.value}"
                                                 rendered="#{columnModelGridMetadatas.isListValues and not empty  columnModelGridMetadatas.listOfValuesPossibles and columnModelGridMetadatas.listOfValuesPossibles[0] ne '' and columnModelGridMetadatas.listOfValuesPossibles[0] ne null}"
                                                 onchange="#{columnModelGridMetadatas.refs ne null or columnModelGridMetadatas.refAutocomplete?'editColumnWithRefresh(':'editColumnWithoutRefresh('}this.value, 0,#{index});">
                                    <f:selectItem itemLabel="" itemValue="#{null}" noSelectionOption="true" />
                                    <f:selectItems
                                        value="#{columnModelGridMetadatas.listOfValuesPossibles}"
                                        var="value" itemLabel="#{value}" itemValue="#{value}" />
                                </h:selectOneMenu>
                                <h:selectOneMenu value="#{columnModelGridMetadatas.value eq ''?null: columnModelGridMetadatas.value}"
                                                 rendered="#{columnModelGridMetadatas.isListValues and (empty  columnModelGridMetadatas.listOfValuesPossibles or columnModelGridMetadatas.listOfValuesPossibles[0] eq '' or columnModelGridMetadatas.listOfValuesPossibles[0] eq null)}"
                                                 onchange="#{columnModelGridMetadatas.refs ne null or columnModelGridMetadatas.refAutocomplete?'editColumnWithRefresh(':'editColumnWithoutRefresh('}this.value, 0,#{index});">
                                    <f:selectItems
                                        value="#{columnModelGridMetadatas.listOfValuesPossibles}"
                                        var="value" itemLabel="#{value}" itemValue="#{value}" />
                                </h:selectOneMenu>
                                <h:inputTextarea value="#{columnModelGridMetadatas.value}"
                                                 styleClass="inputTextAreaLongString"
                                                 onchange="editColumnWithoutRefresh(this.value, 0,#{index}); "
                                                 rendered="#{columnModelGridMetadatas.isLongString}" />
                                <rich:message for="titi" />
                            </h:form>
                        </rich:column>
                    </rich:dataTable>
                </a4j:outputPanel>
                <a4j:outputPanel layout="block" styleClass="wrapperButtonsDialog" id="newLinevalidatePanel" ajaxRendered="true">
                    <h:outputText
                        value="#{refdataManagementPanel.PARAM_MSG_MANDATORY_DATA}"
                        rendered="#{not uiRefdata.lineModelGridMetadataEdited.isValid}"
                        styleClass="mandatory" />
                    <h:outputText
                        value="#{refdataManagementPanel.PARAM_MSG_ALREADY_EXIST}"
                        rendered="#{uiRefdata.lineModelGridMetadataEdited.isValid and uiRefdata.isInKeyPath}"
                        styleClass="mandatory" />
                    <br />
                    <a4j:commandButton value="#{refdataManagementPanel.PARAM_MSG_SAVE2}"
                                       disabled="#{uiRefdata.isInKeyPath or not uiRefdata.lineModelGridMetadataEdited.isValid}"
                                       render="panelValuesMetadatas,saveButton" execute="@this"
                                       limitRender="true" immediate="true"
                                       rendered="#{uiRefdata.isValidNewForm}"
                                       oncomplete="#{rich:component('popupAddNewRefdata')}.hide();#{rich:component('popupSaveDatasConfirmation')}.show();"/>
                    <a4j:commandButton value="#{refdataManagementPanel.PARAM_MSG_CANCEL}"
                                       render="@none" execute="@none" limitRender="true" immediate="true"
                                       oncomplete="deleteNewLine(0); #{rich:component('popupAddNewRefdata')}.hide();" />
                </a4j:outputPanel>


            </rich:popupPanel>
    </div>


        <div class="subcontainer">

            <div class="left">

                <h2>#{refdataManagementPanel.PARAM_MSG_CHOOSE_REFDATA}</h2>
                <p class="intro">#{refdataManagementPanel.PARAM_MSG_CLICK_FOR_CHOOSE_REFDATA}</p>

                <h:panelGroup id="panelListMetadatas">
                    <rich:jQuery selector="#tableMetadatasTable tr" event="mouseover"
                                 query="jQuery(this).addClass('active-row')" />
                    <rich:jQuery selector="#tableMetadatasTable tr" event="mouseout"
                                 query="jQuery(this).removeClass('active-row')" />

                    <rich:dataTable var="metadata" value="#{uiRefdata.metadatas}"
                                    id="tableMetadatasTable" styleClass="dataTable" rows="20"
                                    rowClasses="even-row, odd-row">

                        <rich:column styleClass="nom">
                            <f:facet name="header">
                                <h:outputText
                                    value="#{refdataManagementPanel.PARAM_MSG_REFDATA_LIST}"
                                    style="display: block;" />
                            </f:facet>

                            <a4j:commandLink render="panelDetailsMetadata" execute="@this"
                                             limitRender="true" status="statusWaitSimple">
                                <rich:tooltip styleClass="tooltip" layout="block" showDelay="500">
                                    <h:outputText
                                        value="#{refdataManagementPanel.PARAM_MSG_CLICK_FOR_REFDATA_EDIT}" />
                                </rich:tooltip>
                                <h:outputText value="#{metadata.name}" />

                                <f:setPropertyActionListener
                                    target="#{uiRefdata.metadataSelected}" value="#{metadata}" />
                            </a4j:commandLink>
                        </rich:column>

                    </rich:dataTable>


                    <h:panelGroup layout="block" styleClass="dataTable-scroller">
                        <rich:dataScroller for="tableMetadatasTable" />
                    </h:panelGroup>
                </h:panelGroup>
            </div>


            <div class="right">


                <h:panelGroup id="panelDetailsMetadata">

                    <h:panelGroup
                        styleClass="#{uiRefdata.metadataSelection != null?'':'disabled'}">


                        <h2 style="margin-bottom: 0px; padding-bottom: 0px;">
                            #{refdataManagementPanel.PARAM_MSG_REFDATA_LIST}

                            <h:panelGroup styleClass="panel-currentRefdata-selected">
                                <h:outputText
                                    value="#{refdataManagementPanel.PARAM_MSG_NO_REFDATA_SELECTED}"
                                    rendered="#{uiRefdata.metadataSelection == null}"
                                    styleClass="important" />

                                <h:outputText
                                    value="#{refdataManagementPanel.PARAM_MSG_SELECTION} "
                                    rendered="#{uiRefdata.metadataSelection != null}"
                                    style="color: black; font-weight: normal; " />
                                <h:outputText
                                    value="#{uiRefdata.metadataSelection.metadata.name}"
                                    rendered="#{uiRefdata.metadataSelection != null}" />


                            </h:panelGroup>
                        </h2>
                        <h:panelGroup styleClass="panelControlsRefdataWrapper"
                                      layout="block">
                            <h:panelGroup styleClass="panelControlsRefdata">



                                <h:panelGroup
                                    styleClass="control #{uiRefdata.metadataSelection.download?'':'disabled'}">
                                    <h:graphicImage value="#{resource['images:download.png']}" />
                                    <h:outputLink value="downloadRefdata"
                                                  disabled="#{!uiRefdata.metadataSelection.download}"
                                                  id="downloadButton">
                                        <f:param name="refdatacode"
                                                 value="#{uiRefdata.metadataSelection.metadata.code}" />
                                        <h:outputText
                                            value="#{refdataManagementPanel.PARAM_MSG_DOWNLOAD} " />
                                    </h:outputLink>
                                    <rich:tooltip styleClass="tooltip" layout="block" showDelay="0"
                                                  rendered="#{not uiRefdata.metadataSelection.download}"
                                                  target="downloadButton">
                                        <h:outputText
                                            value="#{refdataManagementPanel.PARAM_MSG_NO_RIGHT_ON_UPLOAD}" />
                                    </rich:tooltip>

                                    <rich:tooltip styleClass="tooltip" layout="block" showDelay="0"
                                                  rendered="#{uiRefdata.metadataSelection.download}"
                                                  target="downloadButton">
                                        <h:outputText
                                            value="#{refdataManagementPanel.PARAM_MSG_CLICK_FOR_DOWNLOAD}" />
                                    </rich:tooltip>
                                </h:panelGroup>

                                <h:panelGroup
                                    rendered="#{not uiRefdata.metadataSelection.metadata.finalMetadata}"
                                    styleClass="#{uiRefdata.metadataSelection.edition?'control':'control disabled'}">
                                    <h:graphicImage value="#{resource['images:add.png']}" />
                                    <h:outputLink
                                        disabled="#{not uiRefdata.metadataSelection.edition}" value="#"
                                        id="addFileRefdata"
                                        onclick="#{rich:component('popupUploadRefdata')}.show();">#{refdataManagementPanel.PARAM_MSG_MASSIV_UPLOAD}</h:outputLink>
                                    <rich:tooltip styleClass="tooltip" layout="block" showDelay="0"
                                                  rendered="#{not uiRefdata.metadataSelection.edition}"
                                                  target="addFileRefdata">
                                        <h:outputText
                                            value="#{refdataManagementPanel.PARAM_MSG_NO_RIGHT_FOR_EDIT}" />
                                    </rich:tooltip>



                                </h:panelGroup>


                                <h:panelGroup
                                    styleClass="#{(uiRefdata.canSave and (uiRefdata.metadataSelection.edition or uiRefdata.metadataSelection.delete))?'control':'control disabled'}"
                                    id="saveButton">
                                    <h:graphicImage value="#{resource['images:save.png']}" />
                                    <a4j:commandLink disabled="#{not uiRefdata.canSave}"
                                                     execute="@none" render="@none" limitRender="true"
                                                     value="#{refdataManagementPanel.PARAM_MSG_SAVE}"
                                                     onclick="#{rich:component('popupSaveDatasConfirmation')}.show()">
                                        <rich:tooltip styleClass="tooltip" layout="block" showDelay="0"
                                                      rendered="#{not (uiRefdata.metadataSelection.edition or uiRefdata.metadataSelection.delete)}">
                                            <h:outputText
                                                value="#{refdataManagementPanel.PARAM_MSG_NO_RIGHT_FOR_EDIT}" />
                                        </rich:tooltip>
                                        <rich:tooltip styleClass="tooltip" layout="block" showDelay="0"
                                                      rendered="#{not uiRefdata.isGridOverallValid}">
                                            <h:outputText styleClass="mandatory"
                                                          value="#{refdataManagementPanel.PARAM_MSG_FILL_MANDATORY_FIELDS}" />
                                        </rich:tooltip>
                                    </a4j:commandLink>
                                </h:panelGroup>
                            </h:panelGroup>
                        </h:panelGroup>

                        <h:panelGroup id="panelValuesMetadatas"
                                      styleClass="panelValuesMetadatas">

                            <rich:jQuery selector="#tableValuesMetadatas tr td.clickable"
                                         event="mouseover" query="jQuery(this).addClass('active-row')" />
                            <rich:jQuery selector="#tableValuesMetadatas tr td.clickable"
                                         event="mouseout" query="jQuery(this).removeClass('active-row')" />
                            <a4j:outputPanel id="panelGroupDatatable" layout="block"
                                             styleClass="panelGroupDatatable" ajaxRendered="true">
                                <rich:dataTable var="line" 
                                                value="#{uiRefdata.modelGridMetadata.linesModelGridMetadatas}"
                                                id="tableValuesMetadatas" iterationStatusVar="lineStatus"
                                                styleClass="dataTable" rows="15" >
                                    <c:forEach items="#{uiRefdata.modelGridMetadata.headersColumns}"
                                               var="header" varStatus="columnStatus">
                                        <rich:column sortBy="#{line.columnsModelGridMetadatas[columnStatus.index].value}"
                                                     styleClass="nom #{line.columnsModelGridMetadatas[columnStatus.index].isListValues or line.columnsModelGridMetadatas[columnStatus.index].isNKey?'':'clickable'} #{line.columnsModelGridMetadatas[columnStatus.index].isNKey?'NKey':''} #{line.toDelete?'deleted':''}">
                                            <f:facet name="header">
                                                <h:outputText value="#{header}" />
                                            </f:facet>

                                            <h:panelGroup rendered="#{not line.isNew}">
                                                <!-- pour une ligne enregistrée affichage d'un champs simple avec une valeur-->
                                                <a4j:commandLink
                                                    value="#{line.columnsModelGridMetadatas[columnStatus.index].value}"
                                                    execute="@none" render="@none"
                                                    onclick="displayPopupEditCellRefdata( &#34;#{line.columnsModelGridMetadatas[columnStatus.index].value} &#34; ,#{lineStatus.index},#{columnStatus.index},#{line.columnsModelGridMetadatas[columnStatus.index].isLongString}); "
                                                    rendered="#{not line.columnsModelGridMetadatas[columnStatus.index].isListValues and not line.columnsModelGridMetadatas[columnStatus.index].isNKey and fn:length(line.columnsModelGridMetadatas[columnStatus.index].value) > 0 and uiRefdata.metadataSelection.edition}">
                                                    <rich:tooltip styleClass="tooltip" layout="block"
                                                                  showDelay="200">
                                                        <h:outputText
                                                            value="#{refdataManagementPanel.PARAM_MSG_CLICK_FOR_EDIT}" />
                                                    </rich:tooltip>
                                                </a4j:commandLink>

                                                <!-- pour une ligne enregistrée affichage d'un champs simple sans valeur-->
                                                <a4j:commandLink value="..." render="@none"
                                                                 onclick="displayPopupEditCellRefdata( &#34;#{line.columnsModelGridMetadatas[columnStatus.index].value} &#34; ,#{lineStatus.index},#{columnStatus.index},#{line.columnsModelGridMetadatas[columnStatus.index].isLongString}); "
                                                                 rendered="#{not line.columnsModelGridMetadatas[columnStatus.index].isListValues and not line.columnsModelGridMetadatas[columnStatus.index].isNKey and fn:length(line.columnsModelGridMetadatas[columnStatus.index].value) == 0 and uiRefdata.metadataSelection.edition}">
                                                    <rich:tooltip styleClass="tooltip" layout="block"
                                                                  showDelay="200">
                                                        <h:outputText
                                                            value="#{refdataManagementPanel.PARAM_MSG_CLICK_FOR_EDIT}" />h
                                                    </rich:tooltip>
                                                </a4j:commandLink>

                                                <!-- pour une ligne enregistrée affichage d'un champs non modifiable -->
                                                <a4j:commandLink
                                                    value="#{line.columnsModelGridMetadatas[columnStatus.index].value}"
                                                    rendered="#{line.columnsModelGridMetadatas[columnStatus.index].isNKey}"
                                                    execute="@none" render="@none" limitRender="true">
                                                    <rich:tooltip styleClass="tooltip" layout="block"
                                                                  showDelay="100">
                                                        <h:outputText
                                                            value="#{refdataManagementPanel.PARAM_MSG_FIELD_READ_ONLY}" />
                                                    </rich:tooltip>
                                                </a4j:commandLink>

                                                <!-- pour une ligne enregistrée affichage d'un champs sans possibilité d'édition pour droits défaillants -->
                                                <a4j:commandLink
                                                    value="#{line.columnsModelGridMetadatas[columnStatus.index].value}"
                                                    rendered="#{not line.columnsModelGridMetadatas[columnStatus.index].isNKey and not uiRefdata.metadataSelection.edition}"
                                                    execute="@none" render="@none" limitRender="true">
                                                    <rich:tooltip styleClass="tooltip" layout="block"
                                                                  showDelay="100">
                                                        <h:outputText
                                                            value="#{refdataManagementPanel.PARAM_MSG_NO_RIGHT_FOR_EDIT}" />
                                                    </rich:tooltip>
                                                </a4j:commandLink>
                                            </h:panelGroup>

                                            <h:panelGroup rendered="#{line.isNew and uiRefdata.metadataSelection.edition}">


                                                <!-- pour une ligne nouvelle affichage d'un champs simple avec une valeur-->
                                                <a4j:commandLink
                                                    value="#{line.columnsModelGridMetadatas[columnStatus.index].value}"
                                                    execute="@none" render="@none"
                                                    onclick="displayPopupEditCellRefdata('#{line.columnsModelGridMetadatas[columnStatus.index].value}',#{lineStatus.index},#{columnStatus.index},#{line.columnsModelGridMetadatas[columnStatus.index].isLongString}); "
                                                    rendered="#{not line.columnsModelGridMetadatas[columnStatus.index].isListValues and fn:length(line.columnsModelGridMetadatas[columnStatus.index].value) > 0}">
                                                    <rich:tooltip styleClass="tooltip" layout="block"
                                                                  showDelay="200">
                                                        <h:outputText
                                                            value="#{refdataManagementPanel.PARAM_MSG_CLICK_FOR_EDIT}" />
                                                    </rich:tooltip>
                                                </a4j:commandLink>

                                                <!-- pour une ligne nouvelle affichage d'un champs simple sans valeur-->
                                                <a4j:commandLink value="..." render="@none"
                                                                 styleClass="newEntry #{line.columnsModelGridMetadatas[columnStatus.index].isValid?'':'invalid'}"
                                                                 onclick="displayPopupEditCellRefdata('#{line.columnsModelGridMetadatas[columnStatus.index].value}',#{lineStatus.index},#{columnStatus.index},#{line.columnsModelGridMetadatas[columnStatus.index].isLongString}); "
                                                                 rendered="#{not line.columnsModelGridMetadatas[columnStatus.index].isListValues and fn:length(line.columnsModelGridMetadatas[columnStatus.index].value) == 0}">

                                                    <!-- champs non obligatoire -->
                                                    <rich:tooltip styleClass="tooltip" layout="block"
                                                                  showDelay="200"
                                                                  rendered="#{line.columnsModelGridMetadatas[columnStatus.index].isValid}">
                                                        <h:outputText
                                                            value="#{refdataManagementPanel.PARAM_MSG_CLICK_FOR_EDIT}" />
                                                    </rich:tooltip>

                                                    <!-- champs obligatoire -->
                                                    <rich:tooltip styleClass="tooltip" layout="block"
                                                                  showDelay="200"
                                                                  rendered="#{not line.columnsModelGridMetadatas[columnStatus.index].isValid}">
                                                        <h:outputText
                                                            value="#{refdataManagementPanel.PARAM_MSG_FILL_MANDATORY_FIELD}" />
                                                    </rich:tooltip>

                                                </a4j:commandLink>

                                            </h:panelGroup>
                                            <!-- pour une ligne enregistrée affichage d'un select-->
                                            <h:form
                                                styleClass="#{line.columnsModelGridMetadatas[columnStatus.index].isValid?'':'invalid'}"
                                                rendered="#{line.columnsModelGridMetadatas[columnStatus.index].isListValues and uiRefdata.metadataSelection.edition}">
                                                <h:selectOneMenu
                                                    value="#{line.columnsModelGridMetadatas[columnStatus.index].value}"
                                                    onchange="editColumn(this.value,#{lineStatus.index},#{columnStatus.index});"
                                                    rendered="#{line.isNew or (!line.columnsModelGridMetadatas[columnStatus.index].isNKey)}">
                                                    <f:selectItems
                                                        value="#{line.columnsModelGridMetadatas[columnStatus.index].listOfValuesPossibles}"
                                                        var="value" itemLabel="#{value}" itemValue="#{value}" />
                                                </h:selectOneMenu>
                                            </h:form>

                                        </rich:column>

                                    </c:forEach>
                                    <rich:column styleClass="actions"
                                                 rendered="#{not uiRefdata.metadataSelection.metadata.finalMetadata}">
                                        <f:facet name="header">
                                            <a4j:commandLink
                                                styleClass="#{(uiRefdata.metadataSelection.edition)?'':'disabled'}"
                                                disabled="#{not uiRefdata.metadataSelection.edition}"
                                                rendered="#{uiRefdata.metadataSelection != null}"
                                                action="#{uiRefdata.addRefdata}" execute="@this"
                                                limitRender="true" render="popupAddNewRefdata"
                                                oncomplete="#{rich:component('popupAddNewRefdata')}.show()">
                                                <h:graphicImage value="#{resource['images:add_ok.png']}" />
                                                <rich:tooltip styleClass="tooltip" layout="block"
                                                              showDelay="0"
                                                              rendered="#{not uiRefdata.metadataSelection.edition}">
                                                    <h:outputText
                                                        value="#{refdataManagementPanel.PARAM_MSG_NO_RIGHT_FOR_EDIT}" />
                                                </rich:tooltip>

                                                <rich:tooltip styleClass="tooltip" layout="block"
                                                              showDelay="0"
                                                              rendered="#{uiRefdata.metadataSelection.edition}">
                                                    <h:outputText
                                                        value="#{refdataManagementPanel.PARAM_MSG_CLICK_FOR_NEW_ENTRY}" />
                                                </rich:tooltip>
                                            </a4j:commandLink>
                                        </f:facet>

                                        <h:outputLink value="#" id="deleteButton" 
                                                      styleClass="#{uiRefdata.metadataSelection.delete?'':'disabled'}"
                                                      disabled="#{not uiRefdata.metadataSelection.delete}"
                                                      onclick="deleteNewLine(#{lineStatus.index});"
                                                      rendered="#{line.isNew}" >
                                            <h:graphicImage value="#{resource['images:delete.png']}" />
                                        </h:outputLink>
                                        <h:outputLink value="#" id="deleteLineButton"
                                                      styleClass="#{uiRefdata.metadataSelection.delete?'':'disabled'}"
                                                      disabled="#{not uiRefdata.metadataSelection.delete}"
                                                      onclick="deleteLine(#{lineStatus.index}); "
                                                      rendered="#{not line.isNew}" >
                                            <h:graphicImage value="#{resource['images:delete.png']}"
                                                            rendered="#{not line.toDelete}" />
                                            <h:graphicImage value="#{resource['images:add_ok.png']}"
                                                            rendered="#{line.toDelete}" />
                                        </h:outputLink>
                                        <rich:tooltip styleClass="tooltip" layout="block"
                                                      rendered="#{line.isNew and uiRefdata.metadataSelection.delete}" showDelay="500" target="deleteButton">
                                            <h:outputText
                                                value="#{refdataManagementPanel.PARAM_MSG_DELETE_LINE}" />
                                        </rich:tooltip>
                                        <rich:tooltip styleClass="tooltip" layout="block"
                                                      showDelay="500" target="deleteLineButton"
                                                      rendered="#{not line.isNew and uiRefdata.metadataSelection.delete}">
                                            <h:outputText
                                                value="#{refdataManagementPanel.PARAM_MSG_DELETE_LINE}"
                                                rendered="#{not line.toDelete}" />
                                            <h:outputText
                                                value="#{refdataManagementPanel.PARAM_MSG_NO_DELETE_LINE}"
                                                rendered="#{line.toDelete}" />
                                        </rich:tooltip>
                                        <rich:tooltip styleClass="tooltip" layout="block"
                                                      rendered="#{not uiRefdata.metadataSelection.delete}" showDelay="500" target="deleteLineButton">
                                            <h:outputText
                                                value="#{refdataManagementPanel.PARAM_MSG_NO_RIGHT_FOR_DELETE}" />
                                        </rich:tooltip>

                                    </rich:column>

                                </rich:dataTable>
                            </a4j:outputPanel>
                            <h:panelGroup layout="block" styleClass="dataTable-scroller">
                                <rich:dataScroller for="tableValuesMetadatas" />
                            </h:panelGroup>
                        </h:panelGroup>
                    </h:panelGroup>
                </h:panelGroup>
            </div>

        </div>




    </composite:implementation>

</html>